Package org.zkoss.io

## Class WriterOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.zkoss.io.WriterOutputStream

- All Implemented Interfaces:
    `java.io.Closeable`, `java.io.Flushable`, `java.lang.AutoCloseable`

      public class WriterOutputStream
      extends java.io.OutputStream

  An output stream that is on top of a writer.
  Author:
    tomyeh

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `WriterOutputStream​(java.io.Writer writer)` | Constructs an output stream assuming UTF-8 encoding.
    `WriterOutputStream​(java.io.Writer writer, java.lang.String charset)` | Constructs an out stream with the specified encoding.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` |
    `void` | `flush()` |
    `void` | `write​(byte[] b)` |
    `void` | `write​(byte[] b, int off, int len)` |
    `void` | `write​(int b)` |

    - ### Methods inherited from class java.io.OutputStream

      `nullOutputStream`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### WriterOutputStream

          public WriterOutputStream​(java.io.Writer writer,
                                    java.lang.String charset)

      Constructs an out stream with the specified encoding.
      Parameters:
        `charset` - the charset. If null, "UTF-8" is assumed.

    - #### WriterOutputStream

          public WriterOutputStream​(java.io.Writer writer)

      Constructs an output stream assuming UTF-8 encoding.

  - ### Method Detail

    - #### write

          public void write​(byte[] b)
                     throws java.io.IOException

      Overrides:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### write

          public void write​(byte[] b,
                            int off,
                            int len)
                     throws java.io.IOException

      Overrides:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### write

          public void write​(int b)
                     throws java.io.IOException

      Specified by:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### flush

          public void flush()
                     throws java.io.IOException

      Specified by:
        `flush` in interface `java.io.Flushable`
      Overrides:
        `flush` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### close

          public void close()
                     throws java.io.IOException

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Overrides:
        `close` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`